Index: palm/trunk/SOURCE/pmc_child_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_child_mod.f90	(revision 2798)
+++ palm/trunk/SOURCE/pmc_child_mod.f90	(revision 2801)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -84,5 +87,5 @@
 !
 ! Child part of Palm Model Coupler
-!-------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 
 #if defined( __parallel )
@@ -97,12 +100,12 @@
 
     USE kinds
-    USE pmc_general,                                                            &
-        ONLY:  arraydef, childdef, da_desclen, da_namedef, da_namelen, pedef,   &
+    USE pmc_general,                                                           &
+        ONLY:  arraydef, childdef, da_desclen, da_namedef, da_namelen, pedef,  &
                pmc_da_name_err,  pmc_g_setname, pmc_max_array, pmc_status_ok
 
-    USE pmc_handle_communicator,                                                &
+    USE pmc_handle_communicator,                                               &
         ONLY:  m_model_comm, m_model_npes, m_model_rank, m_to_parent_comm
 
-    USE pmc_mpi_wrapper,                                                        &
+    USE pmc_mpi_wrapper,                                                       &
         ONLY:  pmc_alloc_mem, pmc_bcast, pmc_inter_bcast, pmc_time
 
@@ -112,8 +115,8 @@
     SAVE
 
-    TYPE(childdef) ::  me   !<
-
-    INTEGER ::  myindex = 0         !< counter and unique number for data arrays
-    INTEGER ::  next_array_in_list = 0   !<
+    TYPE(childdef), PUBLIC ::  me   !<
+
+    INTEGER(iwp) ::  myindex = 0         !< counter and unique number for data arrays
+    INTEGER(iwp) ::  next_array_in_list = 0   !<
 
 
@@ -149,4 +152,5 @@
         MODULE PROCEDURE pmc_c_set_dataarray_2d
         MODULE PROCEDURE pmc_c_set_dataarray_3d
+        MODULE PROCEDURE pmc_c_set_dataarray_ip2d
     END INTERFACE pmc_c_set_dataarray
 
@@ -157,6 +161,6 @@
 
 
-    PUBLIC pmc_childinit, pmc_c_clear_next_array_list, pmc_c_getbuffer,         &
-           pmc_c_getnextarray, pmc_c_putbuffer, pmc_c_setind_and_allocmem,      &
+    PUBLIC pmc_childinit, pmc_c_clear_next_array_list, pmc_c_getbuffer,        &
+           pmc_c_getnextarray, pmc_c_putbuffer, pmc_c_setind_and_allocmem,     &
            pmc_c_set_dataarray, pmc_set_dataarray_name, pmc_c_get_2d_index_list
 
@@ -169,6 +173,6 @@
      IMPLICIT NONE
 
-     INTEGER ::  i        !<
-     INTEGER ::  istat    !<
+     INTEGER(iwp) ::  i        !<
+     INTEGER(iwp) ::  istat    !<
 
 !
@@ -197,5 +201,5 @@
 
 
- SUBROUTINE pmc_set_dataarray_name( parentarraydesc, parentarrayname,           &
+ SUBROUTINE pmc_set_dataarray_name( parentarraydesc, parentarrayname,          &
                                     childarraydesc, childarrayname, istat )
 
@@ -207,11 +211,11 @@
     CHARACTER(LEN=*), INTENT(IN) ::  childarraydesc   !<
 
-    INTEGER, INTENT(OUT) ::  istat  !<
+    INTEGER(iwp), INTENT(OUT) ::  istat  !<
 !
 !-- Local variables
     TYPE(da_namedef) ::  myname  !<
 
-    INTEGER ::  mype  !<
-    INTEGER ::  my_addiarray = 0  !<
+    INTEGER(iwp) ::  mype  !<
+    INTEGER(iwp) ::  my_addiarray = 0  !<
 
 
@@ -219,5 +223,5 @@
 !
 !-- Check length of array names
-    IF ( LEN( TRIM( parentarrayname) ) > da_namelen  .OR.                       &
+    IF ( LEN( TRIM( parentarrayname) ) > da_namelen  .OR.                      &
          LEN( TRIM( childarrayname) ) > da_namelen )  THEN
        istat = pmc_da_name_err
@@ -235,5 +239,7 @@
 !
 !-- Broadcast to all child processes
-!-- TODO: describe what is broadcast here and why it is done
+!
+!-- The complete description of an transfer names array is broadcasted
+
     CALL pmc_bcast( myname%couple_index, 0, comm=m_model_comm )
     CALL pmc_bcast( myname%parentdesc,   0, comm=m_model_comm )
@@ -243,5 +249,7 @@
 !
 !-- Broadcast to all parent processes
-!-- TODO: describe what is broadcast here and why it is done
+!-- The complete description of an transfer array names is broadcasted als to all parent processe
+!   Only the root PE of the broadcasts to parent using intra communicator
+
     IF ( m_model_rank == 0 )  THEN
         mype = MPI_ROOT
@@ -290,8 +298,8 @@
     IMPLICIT NONE
 
-    INTEGER :: dummy               !<
-    INTEGER :: i, ierr, i2, j, nr  !<
-    INTEGER :: indwin              !< MPI window object
-    INTEGER :: indwin2             !< MPI window object
+    INTEGER(iwp) :: dummy               !<
+    INTEGER(iwp) :: i, ierr, i2, j, nr  !<
+    INTEGER(iwp) :: indwin              !< MPI window object
+    INTEGER(iwp) :: indwin2             !< MPI window object
 
     INTEGER(KIND=MPI_ADDRESS_KIND) :: win_size !< Size of MPI window 1 (in bytes)
@@ -307,17 +315,19 @@
 
     win_size = C_SIZEOF( dummy )
-    CALL MPI_WIN_CREATE( dummy, win_size, iwp, MPI_INFO_NULL, me%intra_comm,    &
+    CALL MPI_WIN_CREATE( dummy, win_size, iwp, MPI_INFO_NULL, me%intra_comm,   &
                          indwin, ierr )
 !
-!-- Open window on parent side
-!-- TODO: why is the next MPI routine called twice??
+!-- Close window on child side and open on parent side
     CALL MPI_WIN_FENCE( 0, indwin, ierr )
-!
+
+!   Between the two MPI_WIN_FENCE calls, the parent can fill the RMA window
+
 !-- Close window on parent side and open on child side
+
     CALL MPI_WIN_FENCE( 0, indwin, ierr )
 
     DO  i = 1, me%inter_npes
        disp = me%model_rank * 2
-       CALL MPI_GET( nrele((i-1)*2+1), 2, MPI_INTEGER, i-1, disp, 2,            &
+       CALL MPI_GET( nrele((i-1)*2+1), 2, MPI_INTEGER, i-1, disp, 2,           &
                      MPI_INTEGER, indwin, ierr )
     ENDDO
@@ -347,11 +357,14 @@
 !-- Here, we use a dummy for the MPI window because the parent processes do 
 !-- not access the RMA window via MPI_GET or MPI_PUT
-    CALL MPI_WIN_CREATE( dummy, winsize, iwp, MPI_INFO_NULL, me%intra_comm,     &
+    CALL MPI_WIN_CREATE( dummy, winsize, iwp, MPI_INFO_NULL, me%intra_comm,    &
                          indwin2, ierr )
 !
 !-- MPI_GET is non-blocking -> data in nrele is not available until MPI_FENCE is
 !-- called
-!-- TODO: as before: why is this called twice??
+
     CALL MPI_WIN_FENCE( 0, indwin2, ierr )
+
+!   Between the two MPI_WIN_FENCE calls, the parent can fill the RMA window
+
     CALL MPI_WIN_FENCE( 0, indwin2, ierr )
 
@@ -362,5 +375,5 @@
           disp = nrele(2*(i-1)+1)
           CALL MPI_WIN_LOCK( MPI_LOCK_SHARED , i-1, 0, indwin2, ierr )
-          CALL MPI_GET( myind, 2*nr, MPI_INTEGER, i-1, disp, 2*nr,              &
+          CALL MPI_GET( myind, 2*nr, MPI_INTEGER, i-1, disp, 2*nr,             &
                         MPI_INTEGER, indwin2, ierr )
           CALL MPI_WIN_UNLOCK( i-1, indwin2, ierr )
@@ -424,10 +437,10 @@
     myname = ar%name
 !
-!-- Return true if legal array
-!-- TODO: the case of a non-legal array does not seem to appear, so why is this
-!-- setting required at all?
+!-- Return true if annother array
+!-- If all array have been processed, the RETURN statement a couple of lines above is active
+
     pmc_c_getnextarray = .TRUE.
 
- END function pmc_c_getnextarray
+ END FUNCTION pmc_c_getnextarray
 
 
@@ -439,7 +452,7 @@
     REAL(wp), INTENT(IN) , DIMENSION(:,:), POINTER ::  array  !<
 
-    INTEGER                 ::  i       !<
-    INTEGER                 ::  nrdims  !<
-    INTEGER, DIMENSION(4)   ::  dims    !<
+    INTEGER(iwp)               ::  i       !<
+    INTEGER(iwp)               ::  nrdims  !<
+    INTEGER(iwp), DIMENSION(4) ::  dims    !<
 
     TYPE(C_PTR)             ::  array_adr
@@ -459,4 +472,5 @@
        ar  => ape%array_list(next_array_in_list)
        ar%nrdims = nrdims
+       ar%dimkey = nrdims
        ar%a_dim  = dims
        ar%data   = array_adr
@@ -465,5 +479,35 @@
  END SUBROUTINE pmc_c_set_dataarray_2d
 
-
+ SUBROUTINE pmc_c_set_dataarray_ip2d( array )
+
+    IMPLICIT NONE
+
+    INTEGER(idp), INTENT(IN) , DIMENSION(:,:), POINTER ::  array  !<
+
+    INTEGER(iwp)               ::  i       !<
+    INTEGER(iwp)               ::  nrdims  !<
+    INTEGER(iwp), DIMENSION(4) ::  dims    !<
+
+    TYPE(C_PTR)             ::  array_adr
+    TYPE(arraydef), POINTER ::  ar
+    TYPE(pedef), POINTER    ::  ape
+
+    dims    = 1
+    nrdims  = 2
+    dims(1) = SIZE( array, 1 )
+    dims(2) = SIZE( array, 2 )
+
+    array_adr = C_LOC( array )
+
+    DO  i = 1, me%inter_npes
+       ape => me%pes(i)
+       ar  => ape%array_list(next_array_in_list)
+       ar%nrdims = nrdims
+       ar%dimkey = 22
+       ar%a_dim  = dims
+       ar%data   = array_adr
+    ENDDO
+
+ END SUBROUTINE pmc_c_set_dataarray_ip2d
 
  SUBROUTINE pmc_c_set_dataarray_3d (array)
@@ -473,7 +517,8 @@
     REAL(wp), INTENT(IN), DIMENSION(:,:,:), POINTER ::  array  !<
 
-    INTEGER                 ::  i
-    INTEGER                 ::  nrdims
-    INTEGER, DIMENSION (4)  ::  dims
+    INTEGER(iwp)                ::  i
+    INTEGER(iwp)                ::  nrdims
+    INTEGER(iwp), DIMENSION (4) ::  dims
+    
     TYPE(C_PTR)             ::  array_adr
     TYPE(pedef), POINTER    ::  ape
@@ -493,4 +538,5 @@
        ar  => ape%array_list(next_array_in_list)
        ar%nrdims = nrdims
+       ar%dimkey = nrdims
        ar%a_dim  = dims
        ar%data   = array_adr
@@ -512,19 +558,19 @@
     CHARACTER(LEN=da_namelen) ::  myname  !<
 
-    INTEGER ::  arlen    !<
-    INTEGER ::  myindex  !<
-    INTEGER ::  i        !<
-    INTEGER ::  ierr     !<
-    INTEGER ::  istat    !<
-    INTEGER ::  j        !<
-    INTEGER ::  rcount   !<
-    INTEGER ::  tag      !<
-
-    INTEGER, PARAMETER ::  noindex = -1  !<
+    INTEGER(iwp) ::  arlen    !<
+    INTEGER(iwp) ::  myindex  !<
+    INTEGER(iwp) ::  i        !<
+    INTEGER(iwp) ::  ierr     !<
+    INTEGER(iwp) ::  istat    !<
+    INTEGER(iwp) ::  j        !<
+    INTEGER(iwp) ::  rcount   !<
+    INTEGER(iwp) ::  tag      !<
+
+    INTEGER(iwp), PARAMETER ::  noindex = -1  !<
 
     INTEGER(idp)                   ::  bufsize  !< size of MPI data window
     INTEGER(KIND=MPI_ADDRESS_KIND) ::  winsize  !<
 
-    INTEGER,DIMENSION(1024) ::  req  !<
+    INTEGER(iwp),DIMENSION(1024) ::  req  !<
 
     REAL(wp), DIMENSION(:), POINTER, SAVE ::  base_array_pc  !< base array
@@ -549,11 +595,12 @@
 !--       Receive index from child
           tag = tag + 1
-          CALL MPI_RECV( myindex, 1, MPI_INTEGER, i-1, tag, me%inter_comm,      &
+          CALL MPI_RECV( myindex, 1, MPI_INTEGER, i-1, tag, me%inter_comm,     &
                          MPI_STATUS_IGNORE, ierr )
           ar%recvindex = myindex
 !
 !--       Determine max, because child buffer is allocated only once
-!--       TODO: give a more meaningful comment
-          IF( ar%nrdims == 3 )  THEN
+!--       All 2D and 3d arrays use the same buffer
+
+          IF ( ar%nrdims == 3 )  THEN
              bufsize = MAX( bufsize, ar%a_dim(1)*ar%a_dim(2)*ar%a_dim(3) )
           ELSE
@@ -588,5 +635,5 @@
        DO  j = 1, ape%nr_arrays
           ar => ape%array_list(j)
-          IF( ar%nrdims == 2 )  THEN
+          IF ( ar%nrdims == 2 )  THEN
              arlen = ape%nrele
           ELSEIF( ar%nrdims == 3 )  THEN
@@ -596,16 +643,18 @@
           rcount = rcount + 1
           IF ( ape%nrele > 0 )  THEN
-             CALL MPI_ISEND( myindex, 1, MPI_INTEGER, i-1, tag, me%inter_comm,  &
+             CALL MPI_ISEND( myindex, 1, MPI_INTEGER, i-1, tag, me%inter_comm, &
                              req(rcount), ierr )
              ar%sendindex = myindex
           ELSE
-             CALL MPI_ISEND( noindex, 1, MPI_INTEGER, i-1, tag, me%inter_comm,  &
+             CALL MPI_ISEND( noindex, 1, MPI_INTEGER, i-1, tag, me%inter_comm, &
                              req(rcount), ierr )
              ar%sendindex = noindex
           ENDIF
 !
-!--       Maximum of 1024 outstanding requests
-!--       TODO: explain where this maximum comes from (arbitrary?).
-!--       Outstanding = pending? 
+!--       Maximum of 1024 pending requests
+!         1024 is an arbitrary value just to make sure the number of pending 
+!         requests is getting too large. It is possible that this value has to 
+!         be adjusted in case of running the model on large number of cores. 
+
           IF ( rcount == 1024 )  THEN
              CALL MPI_WAITALL( rcount, req, MPI_STATUSES_IGNORE, ierr )
@@ -640,5 +689,5 @@
     winSize = me%totalbuffersize
 
-    CALL MPI_WIN_CREATE( base_array_cp, winsize, wp, MPI_INFO_NULL,             &
+    CALL MPI_WIN_CREATE( base_array_cp, winsize, wp, MPI_INFO_NULL,            &
                          me%intra_comm, me%win_parent_child, ierr )
     CALL MPI_WIN_FENCE( 0, me%win_parent_child, ierr )
@@ -657,6 +706,6 @@
 !--                the message-routine
              IF ( ar%sendindex+ar%sendsize > bufsize )  THEN
-                WRITE( 0,'(a,i4,4i7,1x,a)') 'Child buffer too small ', i,       &
-                          ar%sendindex, ar%sendsize, ar%sendindex+ar%sendsize,  &
+                WRITE( 0,'(a,i4,4i7,1x,a)') 'Child buffer too small ', i,      &
+                          ar%sendindex, ar%sendsize, ar%sendindex+ar%sendsize, &
                           bufsize, TRIM( ar%name )
                 CALL MPI_ABORT( MPI_COMM_WORLD, istat, ierr )
@@ -670,19 +719,22 @@
 
 
- SUBROUTINE pmc_c_getbuffer( waittime )
+ SUBROUTINE pmc_c_getbuffer( waittime, particle_transfer )
 
     IMPLICIT NONE
 
     REAL(wp), INTENT(OUT), OPTIONAL ::  waittime  !<
+    LOGICAL, INTENT(IN), OPTIONAL   ::  particle_transfer  !<
 
     CHARACTER(LEN=da_namelen) ::  myname  !<
-
-    INTEGER                        ::  ierr     !<
-    INTEGER                        ::  ij       !<
-    INTEGER                        ::  ip       !<
-    INTEGER                        ::  j        !<
-    INTEGER                        ::  myindex  !<
-    INTEGER                        ::  nr       !< number of elements to get
-                                                !< from parent
+    
+    LOGICAL                        ::  lo_ptrans!<
+    
+    INTEGER(iwp)                        ::  ierr    !<
+    INTEGER(iwp)                        ::  ij      !<
+    INTEGER(iwp)                        ::  ip      !<
+    INTEGER(iwp)                        ::  j       !<
+    INTEGER(iwp)                        ::  myindex !<
+    INTEGER(iwp)                        ::  nr      !< number of elements to get
+                                                    !< from parent
     INTEGER(KIND=MPI_ADDRESS_KIND) ::  target_disp
     INTEGER,DIMENSION(1)           ::  buf_shape
@@ -696,4 +748,6 @@
     TYPE(pedef), POINTER                ::  ape
     TYPE(arraydef), POINTER             ::  ar
+    INTEGER(idp), POINTER, DIMENSION(:)     ::  ibuf      !<
+    INTEGER(idp), POINTER, DIMENSION(:,:)   ::  idata_2d  !<
 
 !
@@ -701,4 +755,10 @@
 !-- Therefore the RMA window can be filled without
 !-- sychronization at this point and a barrier is not necessary.
+
+!-- In case waittime is present, the following barrier is necessary to
+!-- insure the same number of barrier calls on parent and child
+!-- This means, that here on child side two barriers are call successively
+!-- The parent is filling its buffer between the two barrier calls
+
 !-- Please note that waittime has to be set in pmc_s_fillbuffer AND
 !-- pmc_c_getbuffer
@@ -709,10 +769,16 @@
        waittime = t2 - t1
     ENDIF
+
+    lo_ptrans = .FALSE.
+    IF ( PRESENT( particle_transfer))    lo_ptrans = particle_transfer
+
 !
 !-- Wait for buffer is filled.
-!-- TODO: explain in more detail what is happening here. The barrier seems to
-!-- contradict what is said a few lines before (i.e. that no barrier is necessary)
-!-- TODO: In case of PRESENT( waittime ) the barrrier would be calles twice. Why?
-!-- Shouldn't it be done the same way as in pmc_putbuffer?
+!
+!-- The parent side (in pmc_s_fillbuffer) is filling the buffer in the MPI RMA window
+!-- When the filling is complet, a MPI_BARRIER is called.
+!-- The child is not allowd to access the parent-buffer before it is completely filled
+!-- therefore the following barrier is required.
+
     CALL MPI_BARRIER( me%intra_comm, ierr )
 
@@ -721,24 +787,40 @@
        DO  j = 1, ape%nr_arrays
           ar => ape%array_list(j)
-          IF ( ar%nrdims == 2 )  THEN
+
+          IF ( ar%dimkey == 2 .AND. .NOT.lo_ptrans)  THEN
              nr = ape%nrele
-          ELSEIF ( ar%nrdims == 3 )  THEN
+          ELSEIF ( ar%dimkey == 3 .AND. .NOT.lo_ptrans)  THEN
              nr = ape%nrele * ar%a_dim(1)
+          ELSE IF ( ar%dimkey == 22 .AND. lo_ptrans)  THEN
+             nr = ape%nrele
+          ELSE
+             CYCLE                    ! Particle array ar not transferd here
           ENDIF
           buf_shape(1) = nr
-          CALL C_F_POINTER( ar%recvbuf, buf, buf_shape )
+          IF ( lo_ptrans )   THEN
+             CALL C_F_POINTER( ar%recvbuf, ibuf, buf_shape )
+          ELSE
+             CALL C_F_POINTER( ar%recvbuf, buf, buf_shape )
+          ENDIF
 !
 !--       MPI passive target RMA
-!--       TODO: explain the above comment
+!--       One data array is fetcht from MPI RMA window on parent
+
           IF ( nr > 0 )  THEN
              target_disp = ar%recvindex - 1
-             CALL MPI_WIN_LOCK( MPI_LOCK_SHARED , ip-1, 0,                      &
+             CALL MPI_WIN_LOCK( MPI_LOCK_SHARED , ip-1, 0,                     &
                                 me%win_parent_child, ierr )
-             CALL MPI_GET( buf, nr, MPI_REAL, ip-1, target_disp, nr, MPI_REAL,  &
-                                me%win_parent_child, ierr )
+             IF ( lo_ptrans )   THEN
+                CALL MPI_GET( ibuf, nr*8, MPI_BYTE, ip-1, target_disp, nr*8, MPI_BYTE,  &               !There is no MPI_INTEGER8 datatype
+                                   me%win_parent_child, ierr )
+             ELSE
+                CALL MPI_GET( buf, nr, MPI_REAL, ip-1, target_disp, nr,        &
+                              MPI_REAL, me%win_parent_child, ierr )
+             ENDIF
              CALL MPI_WIN_UNLOCK( ip-1, me%win_parent_child, ierr )
           ENDIF
           myindex = 1
-          IF ( ar%nrdims == 2 )  THEN
+          IF ( ar%dimkey == 2 .AND. .NOT.lo_ptrans)  THEN
+
              CALL C_F_POINTER( ar%data, data_2d, ar%a_dim(1:2) )
              DO  ij = 1, ape%nrele
@@ -746,11 +828,22 @@
                 myindex = myindex + 1
              ENDDO
-          ELSEIF ( ar%nrdims == 3 )  THEN
+
+          ELSEIF ( ar%dimkey == 3 .AND. .NOT.lo_ptrans)  THEN
+
              CALL C_F_POINTER( ar%data, data_3d, ar%a_dim(1:3) )
              DO  ij = 1, ape%nrele
-                data_3d(:,ape%locind(ij)%j,ape%locind(ij)%i) =                  &
+                data_3d(:,ape%locind(ij)%j,ape%locind(ij)%i) =                 &
                                               buf(myindex:myindex+ar%a_dim(1)-1)
                 myindex = myindex+ar%a_dim(1)
              ENDDO
+
+          ELSEIF ( ar%dimkey == 22 .AND. lo_ptrans)  THEN
+             CALL C_F_POINTER( ar%data, idata_2d, ar%a_dim(1:2) )
+
+             DO  ij = 1, ape%nrele
+                idata_2d(ape%locind(ij)%j,ape%locind(ij)%i) = ibuf(myindex)
+                myindex = myindex + 1
+             ENDDO
+
           ENDIF
        ENDDO
@@ -761,40 +854,51 @@
 
 
- SUBROUTINE pmc_c_putbuffer( waittime )
+ SUBROUTINE pmc_c_putbuffer( waittime , particle_transfer )
 
     IMPLICIT NONE
 
     REAL(wp), INTENT(OUT), OPTIONAL ::  waittime  !<
+    LOGICAL, INTENT(IN), OPTIONAL   ::  particle_transfer  !<
 
     CHARACTER(LEN=da_namelen) ::  myname  !<
-
-    INTEGER                        ::  ierr         !<
-    INTEGER                        ::  ij           !<
-    INTEGER                        ::  ip           !<
-    INTEGER                        ::  j            !<
-    INTEGER                        ::  myindex      !<
-    INTEGER                        ::  nr           !< number of elements to get
-                                                    !< from parent
+    
+    LOGICAL ::  lo_ptrans!<
+    
+    INTEGER(iwp) ::  ierr         !<
+    INTEGER(iwp) ::  ij           !<
+    INTEGER(iwp) ::  ip           !<
+    INTEGER(iwp) ::  j            !<
+    INTEGER(iwp) ::  myindex      !<
+    INTEGER(iwp) ::  nr           !< number of elements to get from parent
+    
     INTEGER(KIND=MPI_ADDRESS_KIND) ::  target_disp  !<
-
-    INTEGER, DIMENSION(1)          ::  buf_shape    !<
+    
+
+    INTEGER(iwp), DIMENSION(1) ::  buf_shape    !<
 
     REAL(wp) ::  t1  !<
     REAL(wp) ::  t2  !<
 
-    REAL(wp), POINTER, DIMENSION(:)     ::  buf      !<
-    REAL(wp), POINTER, DIMENSION(:,:)   ::  data_2d  !<
-    REAL(wp), POINTER, DIMENSION(:,:,:) ::  data_3d  !<
-
-    TYPE(pedef), POINTER               ::  ape  !<
-    TYPE(arraydef), POINTER            ::  ar   !<
+    REAL(wp), POINTER, DIMENSION(:)         ::  buf      !<
+    REAL(wp), POINTER, DIMENSION(:,:)       ::  data_2d  !<
+    REAL(wp), POINTER, DIMENSION(:,:,:)     ::  data_3d  !<
+    
+    INTEGER(idp), POINTER, DIMENSION(:)     ::  ibuf      !<
+    INTEGER(idp), POINTER, DIMENSION(:,:)   ::  idata_2d  !<
+
+    TYPE(pedef), POINTER                    ::  ape  !<
+    TYPE(arraydef), POINTER                 ::  ar   !<
 
 !
 !-- Wait for empty buffer
-!-- TODO: explain what is done here
+!-- Switch RMA epoche
+
     t1 = pmc_time()
     CALL MPI_BARRIER( me%intra_comm, ierr )
     t2 = pmc_time()
     IF ( PRESENT( waittime ) )  waittime = t2 - t1
+
+    lo_ptrans = .FALSE.
+    IF ( PRESENT( particle_transfer))    lo_ptrans = particle_transfer
 
     DO  ip = 1, me%inter_npes
@@ -803,5 +907,7 @@
           ar => aPE%array_list(j)
           myindex = 1
-          IF ( ar%nrdims == 2 )  THEN
+
+          IF ( ar%dimkey == 2 .AND. .NOT.lo_ptrans )  THEN
+
              buf_shape(1) = ape%nrele
              CALL C_F_POINTER( ar%sendbuf, buf,     buf_shape     )
@@ -811,5 +917,7 @@
                 myindex = myindex + 1
              ENDDO
-          ELSEIF ( ar%nrdims == 3 )  THEN
+
+          ELSEIF ( ar%dimkey == 3 .AND. .NOT.lo_ptrans )  THEN
+
              buf_shape(1) = ape%nrele*ar%a_dim(1)
              CALL C_F_POINTER( ar%sendbuf, buf,     buf_shape     )
@@ -820,13 +928,23 @@
                 myindex = myindex + ar%a_dim(1)
              ENDDO
+
+          ELSE IF ( ar%dimkey == 22 .AND. lo_ptrans)  THEN
+
+             buf_shape(1) = ape%nrele
+             CALL C_F_POINTER( ar%sendbuf, ibuf,     buf_shape     )
+             CALL C_F_POINTER( ar%data,    idata_2d, ar%a_dim(1:2) )
+
+             DO  ij = 1, ape%nrele
+                ibuf(myindex) = idata_2d(ape%locind(ij)%j,ape%locind(ij)%i)
+                myindex = myindex + 1
+             ENDDO
+
           ENDIF
        ENDDO
     ENDDO
 !
-!-- TODO: Fence might do it, test later
-!-- Call MPI_WIN_FENCE( 0, me%win_parent_child, ierr)      !
-!
 !-- Buffer is filled
-!-- TODO: explain in more detail what is happening here
+!-- Switch RMA epoche
+
     CALL MPI_Barrier(me%intra_comm, ierr)
 
Index: palm/trunk/SOURCE/pmc_general_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_general_mod.f90	(revision 2798)
+++ palm/trunk/SOURCE/pmc_general_mod.f90	(revision 2801)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -88,22 +91,23 @@
     SAVE
 
-    INTEGER, PARAMETER, PUBLIC :: da_desclen       =  8  !<
-    INTEGER, PARAMETER, PUBLIC :: da_namelen       = 16  !<
-    INTEGER, PARAMETER, PUBLIC :: pmc_da_name_err  = 10  !<
-    INTEGER, PARAMETER, PUBLIC :: pmc_max_array    = 32  !< max # of arrays which can be coupled
-    INTEGER, PARAMETER, PUBLIC :: pmc_max_models   = 64  !<
-    INTEGER, PARAMETER, PUBLIC :: pmc_status_ok    =  0  !<
-    INTEGER, PARAMETER, PUBLIC :: pmc_status_error = -1  !<
+    INTEGER(iwp), PARAMETER, PUBLIC :: da_desclen       =  8  !<
+    INTEGER(iwp), PARAMETER, PUBLIC :: da_namelen       = 16  !<
+    INTEGER(iwp), PARAMETER, PUBLIC :: pmc_da_name_err  = 10  !<
+    INTEGER(iwp), PARAMETER, PUBLIC :: pmc_max_array    = 32  !< max # of arrays which can be coupled
+    INTEGER(iwp), PARAMETER, PUBLIC :: pmc_max_models   = 64  !<
+    INTEGER(iwp), PARAMETER, PUBLIC :: pmc_status_ok    =  0  !<
+    INTEGER(iwp), PARAMETER, PUBLIC :: pmc_status_error = -1  !<
 
 
     TYPE, PUBLIC :: xy_ind  !< pair of indices in horizontal plane
-       INTEGER ::  i
-       INTEGER ::  j
+       INTEGER(iwp) ::  i
+       INTEGER(iwp) ::  j
     END TYPE
 
     TYPE, PUBLIC ::  arraydef
-       INTEGER                   :: coupleindex  !<
-       INTEGER                   :: nrdims       !< number of dimensions
-       INTEGER, DIMENSION(4)     :: a_dim        !< size of dimensions
+       INTEGER(iwp)                   :: coupleindex  !<
+       INTEGER(iwp)                   :: nrdims       !< number of dimensions
+       INTEGER(iwp)                   :: dimkey       !< key for NR dimensions and array type
+       INTEGER(iwp), DIMENSION(4)     :: a_dim        !< size of dimensions
        TYPE(C_PTR)               :: data         !< pointer of data in parent space
        TYPE(C_PTR), DIMENSION(2) :: po_data      !< base pointers,
@@ -112,6 +116,6 @@
        INTEGER(idp)              :: SendIndex    !< index in send buffer
        INTEGER(idp)              :: RecvIndex    !< index in receive buffer
-       INTEGER                   :: SendSize     !< size in send buffer
-       INTEGER                   :: RecvSize     !< size in receive buffer
+       INTEGER(iwp)              :: SendSize     !< size in send buffer
+       INTEGER(iwp)              :: RecvSize     !< size in receive buffer
        TYPE(C_PTR)               :: SendBuf      !< data pointer in send buffer
        TYPE(C_PTR)               :: RecvBuf      !< data pointer in receive buffer
@@ -123,6 +127,6 @@
 
     TYPE, PUBLIC ::  pedef
-       INTEGER :: nr_arrays = 0  !< number of arrays which will be transfered
-       INTEGER :: nrele          !< number of elements, same for all arrays
+       INTEGER(iwp) :: nr_arrays = 0  !< number of arrays which will be transfered
+       INTEGER(iwp) :: nrele          !< number of elements, same for all arrays
        TYPE(xy_ind), POINTER, DIMENSION(:)   ::  locInd      !< xy index local array for remote PE
        TYPE(arraydef), POINTER, DIMENSION(:) ::  array_list  !< list of data arrays to be transfered
@@ -131,17 +135,17 @@
     TYPE, PUBLIC ::  childdef
        INTEGER(idp) ::  totalbuffersize    !<
-       INTEGER      ::  model_comm         !< communicator of this model
-       INTEGER      ::  inter_comm         !< inter communicator model and child
-       INTEGER      ::  intra_comm         !< intra communicator model and child
-       INTEGER      ::  model_rank         !< rank of this model
-       INTEGER      ::  model_npes         !< number of PEs this model
-       INTEGER      ::  inter_npes         !< number of PEs child model
-       INTEGER      ::  intra_rank         !< rank within intra_comm
-       INTEGER      ::  win_parent_child   !< MPI RMA for preparing data on parent AND child side
+       INTEGER(iwp) ::  model_comm         !< communicator of this model
+       INTEGER(iwp) ::  inter_comm         !< inter communicator model and child
+       INTEGER(iwp) ::  intra_comm         !< intra communicator model and child
+       INTEGER(iwp) ::  model_rank         !< rank of this model
+       INTEGER(iwp) ::  model_npes         !< number of PEs this model
+       INTEGER(iwp) ::  inter_npes         !< number of PEs child model
+       INTEGER(iwp) ::  intra_rank         !< rank within intra_comm
+       INTEGER(iwp) ::  win_parent_child   !< MPI RMA for preparing data on parent AND child side
        TYPE(pedef), DIMENSION(:), POINTER ::  pes  !< list of all child PEs
     END TYPE childdef
 
     TYPE, PUBLIC ::  da_namedef  !< data array name definition
-       INTEGER                   ::  couple_index  !< unique number of array
+       INTEGER(iwp)              ::  couple_index  !< unique number of array
        CHARACTER(LEN=da_desclen) ::  parentdesc    !< parent array description
        CHARACTER(LEN=da_namelen) ::  nameonparent  !< name of array within parent
@@ -168,9 +172,9 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*)               ::  aname         !<
-    INTEGER, INTENT(IN)            ::  couple_index  !<
-    TYPE(childdef), INTENT(INOUT)  ::  mychild       !<
-
-    INTEGER ::  i  !<
+    CHARACTER(LEN=*)              ::  aname         !<
+    INTEGER(iwp), INTENT(IN)      ::  couple_index  !<
+    TYPE(childdef), INTENT(INOUT) ::  mychild       !<
+
+    INTEGER(iwp) ::  i  !<
 
     TYPE(arraydef), POINTER ::  ar   !<
@@ -195,12 +199,12 @@
     IMPLICIT NONE
 
-    INTEGER, INTENT(IN)                    ::  sort_ind
-    INTEGER, DIMENSION(:,:), INTENT(INOUT) ::  array
-
-    INTEGER ::  i  !<
-    INTEGER ::  j  !<
-    INTEGER ::  n  !<
-
-    INTEGER, DIMENSION(SIZE(array,1)) ::  tmp  !<
+    INTEGER(iwp), INTENT(IN)                    ::  sort_ind
+    INTEGER(iwp), DIMENSION(:,:), INTENT(INOUT) ::  array
+
+    INTEGER(iwp) ::  i  !<
+    INTEGER(iwp) ::  j  !<
+    INTEGER(iwp) ::  n  !<
+
+    INTEGER(iwp), DIMENSION(SIZE(array,1)) ::  tmp  !<
 
     n = SIZE(array,2)
Index: palm/trunk/SOURCE/pmc_handle_communicator_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 2798)
+++ palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 2801)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -142,9 +145,9 @@
 
     INTEGER ::  m_world_comm  !< global nesting communicator
-    INTEGER ::  m_my_cpl_id   !< coupler id of this modelfortran return
+    INTEGER ::  m_my_cpl_id   !< coupler id of this model
     INTEGER ::  m_parent_id   !< coupler id of parent of this model
     INTEGER ::  m_ncpl        !< number of couplers given in nestpar namelist
 
-    TYPE(pmc_layout), DIMENSION(pmc_max_models) ::  m_couplers  !< information of all couplers
+    TYPE(pmc_layout), PUBLIC, DIMENSION(pmc_max_models) ::  m_couplers  !< information of all couplers
 
     INTEGER, PUBLIC ::  m_model_comm          !< communicator of this model
@@ -221,5 +224,5 @@
        THEN
 !
-!--       Determine the first process id of each model
+!--       Calculate start PE of every model
           start_pe(1) = 0
           DO  i = 2, m_ncpl+1
